"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.App = void 0;
var tslib_1 = require("tslib");
var path_1 = (0, tslib_1.__importDefault)(require("path"));
var download_1 = (0, tslib_1.__importDefault)(require("download"));
var printer_1 = require("@packi_/printer");
var perf_1 = (0, tslib_1.__importDefault)(require("@packi_/utils/cjs/perf"));
var packageJSON_1 = (0, tslib_1.__importDefault)(require("@packi_/utils/cjs/package/packageJSON"));
var compareVersion_1 = (0, tslib_1.__importDefault)(require("@packi_/utils/cjs/version/compareVersion"));
var getAction_1 = (0, tslib_1.__importDefault)(require("./getAction"));
var PACKAGE_INFO_URL = "http://registry.npm.taobao.org/packi";
var App = /** @class */ (function () {
    function App(args, cwd) {
        this.packageName = "";
        this.packageVersion = "";
        this.appArgs = args.slice(2);
        this.cwd = cwd;
        this.command = this.appArgs[0];
        if (this.appArgs.find(function (el) { return el === "-D"; })) {
            (0, printer_1.setPrintLevel)(printer_1.PRINT_LEVEL.DEBUG);
        }
        else {
            (0, printer_1.setPrintLevel)(printer_1.PRINT_LEVEL.INFO);
        }
    }
    App.prototype.run = function () {
        var _a, _b, _c, _d;
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var end, _e, command, cammandAction, retCode, end_1, err_1;
            return (0, tslib_1.__generator)(this, function (_f) {
                switch (_f.label) {
                    case 0: return [4 /*yield*/, this.prepare2Run()];
                    case 1:
                        _f.sent();
                        end = (0, perf_1.default)("find action entry");
                        _e = this.command, command = _e === void 0 ? "help" : _e;
                        return [4 /*yield*/, (0, getAction_1.default)(command)];
                    case 2:
                        cammandAction = _f.sent();
                        if (typeof cammandAction !== "function") {
                            (0, printer_1.error)("Bad command: \"".concat(command, "\", packi can't load the command implemention."));
                            return [2 /*return*/, 1];
                        }
                        end();
                        retCode = 0;
                        _f.label = 3;
                    case 3:
                        _f.trys.push([3, 5, , 6]);
                        end_1 = (0, perf_1.default)("run action");
                        return [4 /*yield*/, cammandAction.apply(void 0, (0, tslib_1.__spreadArray)([this.cwd], this.appArgs, false))];
                    case 4:
                        retCode = _f.sent();
                        end_1();
                        return [3 /*break*/, 6];
                    case 5:
                        err_1 = _f.sent();
                        (0, printer_1.error)((_d = (_b = (_a = err_1) === null || _a === void 0 ? void 0 : _a.stack) !== null && _b !== void 0 ? _b : (_c = err_1) === null || _c === void 0 ? void 0 : _c.message) !== null && _d !== void 0 ? _d : err_1);
                        retCode = 1;
                        return [3 /*break*/, 6];
                    case 6:
                        if (!retCode) {
                            (0, printer_1.success)("Mission accomplished.");
                        }
                        return [2 /*return*/, retCode];
                }
            });
        });
    };
    App.prototype.prepare2Run = function () {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var _a, name_1, version, err_2;
            return (0, tslib_1.__generator)(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _b.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, (0, packageJSON_1.default)(path_1.default.resolve(__dirname, "../"))];
                    case 1:
                        _a = _b.sent(), name_1 = _a.name, version = _a.version;
                        this.packageName = name_1;
                        this.packageVersion = version;
                        this.printAppInfo();
                        this.checkVersion();
                        return [3 /*break*/, 3];
                    case 2:
                        err_2 = _b.sent();
                        (0, printer_1.error)(err_2.message);
                        (0, printer_1.error)("Try to continue...");
                        return [3 /*break*/, 3];
                    case 3: return [2 /*return*/];
                }
            });
        });
    };
    App.prototype.printAppInfo = function () {
        (0, printer_1.printPackageInfo)(this.packageName, this.packageVersion);
    };
    App.prototype.checkVersion = function () {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function () {
            var data, jsonText, schema, latestVersion, version;
            return (0, tslib_1.__generator)(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, (0, download_1.default)(PACKAGE_INFO_URL)];
                    case 1:
                        data = _a.sent();
                        jsonText = data.toString("utf8");
                        schema = JSON.parse(jsonText);
                        latestVersion = schema["dist-tags"]["latest"];
                        version = this.packageVersion;
                        if ((0, compareVersion_1.default)(latestVersion, version) > 0) {
                            //if (onlineVersion !== version) {
                            //存在新版本
                            (0, printer_1.warn)("\n");
                            (0, printer_1.warn)(">>>>------- IMPORTANT INFORMATION -------<<<<");
                            (0, printer_1.warn)("A newer version(".concat(latestVersion, ") has been published."));
                            (0, printer_1.warn)("Please upgrade your local package(".concat(version, ") soon."));
                            (0, printer_1.warn)(">>>>-------------------------------------<<<<");
                            (0, printer_1.warn)("\n");
                        }
                        return [2 /*return*/];
                }
            });
        });
    };
    return App;
}());
exports.App = App;
